﻿//Эта программа создаёт граф из всех слов
//Файл со словами взят из C:\Program Files (x86)\PascalABC.NET\Files\Databases

type
  Node = class
    
    s: string;
    next := new List<Node>(1000);
    
    constructor(s: string);
    begin
      self.s := s;
    end;
    
  end;
  NodeComparer = class(IComparer<Node>)
    
    public function Compare(x, y: Node): integer := x.s.CompareTo(y.s);
    
  end;

//так получается 24323 не связаных графов, так что не годится
function CanConvert1(s1, s2: string): boolean;
begin
  var dl := abs(s1.Length-s2.Length);
  
  if dl = 0 then
  begin
    var c := 0;
    
    for var i := 1 to s1.Length do
      if s1[i]=s2[i] then c += 1;
    
    Result := c = s1.Length-1;
  end else
  if dl = 1 then
  begin
    
    if s1.Length>s2.Length then
      Result := s1.Substring(0,s2.Length) = s2 else
      Result := s2.Substring(0,s1.Length) = s1;
    
  end else
    Result := false;
end;

function CanConvert(s1, s2: string): boolean;
begin
  if s1.Length > s2.Length then
    s1 := s1.Substring(0,s2.Length) else
    s2 := s2.Substring(0,s1.Length);
  
  var c := 0;
  
  for var i := 1 to s1.Length do
    if s1[i]=s2[i] then c += 1;
  
  Result := c > s1.Length-2;
end;

begin
  var wds := ReadAllLines('words.txt').Where(s-> s.Length>2 ).Select(w->w.ToLower).Order.WriteLines('words.txt').ToArray;
  var nds: array of Node := wds.ConvertAll(w->new Node(w));
  
  var d_text: string;
  var done, total: integer;
  var otp := System.Threading.Thread.Create(()->
  while true do
  begin
    writeln(d_text);
    writeln($'done {done} of {total}, {done/total:P}');
    Sleep(30);
    System.Console.Clear;
  end);
  otp.Start;
  
  //==================================================
  
  total := wds.Length*(wds.Length-1) div 2;
  
  for var i := 0 to wds.Length-1 do
  begin
    var w := wds[i];
    var n := nds[i];
    
    for var i2 := i+1 to wds.Length-1 do
    begin
      
      if CanConvert(w,wds[i2]) then
      begin
        var n2 := nds[i2];
        n.next += n2;
        n2.next += n;
      end;
      
      done += 1;
    end;
    
    d_text := w;
  end;
  
  //==================================================
  
  done := 0;
  total := wds.Length;
  
  var nds_left := nds.ToList;
  var res := new List<List<Node>>;
  while nds_left.Count>0 do
  begin
    d_text := $'group #{res.Count}';
    var cres := new HashSet<Node>;
    cres.Add(nds_left[nds_left.Count-1]);
    done += 1;
    nds_left.RemoveLast;
    
    var last_added := new List<Node>;
    last_added += cres.First;
    
    var no_new: boolean;
    repeat
      no_new := true;
      
      var new_added := new List<Node>;
      foreach var nn in last_added do
        foreach var n in nn.next do
          if cres.Add(n) then
          begin
            done += 1;
            no_new := false;
            new_added += n;
          end;
      last_added := new_added;
      
    until no_new;
    
    nds_left.RemoveAll(n->cres.Contains(n));
    res += cres.OrderBy(n->n.s).ToList;
  end;
  
  //==================================================
  
  done := 0;
  total := wds.Length;
  d_text := $'saving {res.Count} graphs';
  
  var bw := new System.IO.BinaryWriter(System.IO.File.Create('words.database'));
  bw.Write(res.Count);
  foreach var cres in res do
  begin
    bw.Write(cres.Count);
    
    foreach var n in cres do
    begin
      bw.Write(n.s);
      bw.Write(n.next.Count);
      
      foreach var l in n.next do
        bw.Write(cres.BinarySearch(l, new NodeComparer));
      
      done += 1;
    end;
    
  end;
  bw.Close;
  
  //==================================================
  
  otp.Abort;
  
end.